#!/bin/bash

# Utilisation uniquement comme sous programme
# Requis : sha1sum. Pour vérifier, taper en console : "sha1sum --help"

# Rafael Venancio
# 29/05/2009 Version initiale



#$1 : basename de l'archive Dar. Nom de l'archive.
#$2 : numéro de l'archive Dar. Numéro du fichier de l'archive.
formatFichier="$3" 
targetDir="$4" 
backupDir="$5"
diskDir="$6"
ZONETMP="$7" # chemin du répertoire temporaire
TESTPRESENCE="$8" # pour vérifier la présence du sous-programme. true = c'est le test. false = création archive. 



# Pour vérification de la présence du sous-programme
#==============================================================================
if [ "$TESTPRESENCE" == "true" ]; then
	exit 0
fi


# Pour ne pas utiliser le script tout seul
#==============================================================================
if [ "$#" = 0 ]; then
	echo "Attention !"
	echo "Ce script est un sous-programme de du script 'SauvegardeGeneralePC.sh'." 
	echo "Il ne peut fonctionner tout seul."
	echo "Interruption du script."
	echo " "
	echo " "
	echo " "
	setterm -cursor on # Demasquage du curseur
	exit 0
fi 



echo "Fichier $1.$2.$formatFichier"
echo -n " - création... "

cd $ZONETMP # Déplacement vers le répertoire temporaire où se trouve le fichier 'dar'

echo -n "checksum... "
#==============================================================================
sha1sum "$1.$2.$formatFichier" > "$1.$2.$formatFichier".sha1



echo -n "copie... "
#==============================================================================
COPIEOK="true"

cp "$1.$2.$formatFichier" "$targetDir/$backupDir/$diskDir/"
if [ "$?" -ne "0" ]; then # le '$?' == code sortie de la dernière commande'
	echo "echec"
	COPIEOK="false"
fi	

cp "$1.$2.$formatFichier.sha1"  "$targetDir/$backupDir/$diskDir/"
if [ "$?" -ne "0" ]; then # le '$?' == code sortie de la dernière commande'
	echo "echec"
	COPIEOK="false"
fi	

if [ "$COPIEOK" != "true" ]; then
	echo "Copie : echec"
	echo " "
	echo "Interruption du script."
	echo "Traiter le problème et relancer le script"
	echo " "
	echo " "
	echo " "
	setterm -cursor on # Demasquage du curseur
	exit 1
fi



echo -n "verification... "
#==============================================================================
sha1sum -c $targetDir/$backupDir/$diskDir/"$1.$2.$formatFichier".sha1 >/dev/null

if [ "$?" -ne "0" ]; then # le '$?' == code sortie de la dernière commande'
	echo "echec"
	echo " "
	echo "Interruption du script."
	echo "Traiter le problème et relancer le script"
	echo " "
	echo " "
	echo " "
	setterm -cursor on # Demasquage du curseur
	exit 1
fi	



echo -n "suppression... "
#==============================================================================
EFFACEROK="true"
	
rm "$1.$2.$formatFichier"
if [ "$?" -ne "0" ]; then # le '$?' == code sortie de la dernière commande' 
	echo "echec fichier $1.$2.$formatFichier"
	EFFACEROK="false"
fi

rm "$1.$2.$formatFichier.sha1"
if [ "$?" -ne "0" ]; then # le '$?' == code sortie de la dernière commande'
	echo "echec fichier $1.$2.$formatFichier.sha1"
	EFFACEROK="false"
fi	
	
if [ "$EFFACEROK" == "true" ]; then
	echo "OK"
else
	echo "echec"
	echo " "
	echo "Interruption du script."
	echo "Traiter le problème et relancer le script"
	echo " "
	echo " "
	echo " "
	setterm -cursor on # Demasquage du curseur
	exit 1
fi




exit 0
